Attribute VB_Name = "Global_declarations_and_procedures"
Attribute VB_Description = "Global Definitions"
'This module contains global and generally handy routines used by most of
'the modules along with the data definitions used by all the modules.

Public HelpDialogue As Control

Option Compare Text

'Check box constants
Public Const Checked = 1
Public Const Unchecked = 0
Public Const Grayed = 2

'TRANSACTION LOG CONSTANTS
'Main transaction log
Public Const Main_tran_log_Borrow = 10
Public Const Main_tran_log_Ext_Loan = 11
Public Const Main_tran_log_Return = 20
Public Const Main_tran_log_Del_Loan = 21
Public Const Main_tran_log_Request = 30
Public Const Main_tran_log_Req_process = 31
Public Const Main_tran_log_Ext_Request = 32
Public Const Main_tran_log_Del_Request = 33

'Books transactiuon log
Public Const Books_tran_log_New = 50
Public Const Books_tran_log_Edit = 51
Public Const Books_tran_log_Deregister = 52

'Subscriber transaction log
Public Const Subscriber_tran_log_New = 60
Public Const Subscriber_tran_log_Edit = 61
Public Const Subscriber_tran_log_Deregister = 62

'User transaction log - Area constants
Public Const Area_Main = 1
Public Const Area_Security = 2
Public Const Area_Backup = 3
Public Const Area_Optimise = 4
Public Const Area_Restore = 5
Public Const Area_Transactions = 6
Public Const Area_Report = 7
Public Const Area_Query = 8

Public Subscriber_Id_format(1 To 8) As String
Public DateFormat As String
Public New_line As String
Public Response As Integer
Public Last_viewed As String
Public Character As String * 1
Public mySQL As String
Public Counter As Long
Public mySortIndex As String
Public myBookMark As String
Public Locate_string As String
Public Const FileMustExist = &H1000&
Public Const HidePrintToFile = &H10000

Public Temp_recordset As Recordset
Public Search_recordset As Recordset

Public MyWorkspace As Workspace
Public Transaction_db As Database

Public Main_log_table As TableDef
Public Subscriber_log_table As TableDef
Public Books_log_table As TableDef
Public Main_query As QueryDef
Public Book_query As QueryDef
Public Subscriber_query As QueryDef
Public Security_query As QueryDef

Public Main_log As Recordset
Public DateField As Field
Public TypeField As Field
Public AmountField As Field
Public Extra_date As Field


Public Subscriber_log As Recordset
Public Books_log As Recordset
Public Edited_fields As Field

Public Libra As Database
Public Working_database As Database

Public Query As QueryDef

Public Setup_table As TableDef
Public Identifier As Field
Public Variable As Field

Public Setup As Recordset

Public Setup_index As Index


Public Book_number_index As Index
Public SubscriberID_index As Index
Public Name_index As Index
Public Registered_on_index As Index
Public Expiry_date_index As Index
Public Deregistered_on_index As Index
Public Reason_index As Index
Public Author_index As Index
Public Title_index As Index
Public Dewey_index As Index
Public Class_index As Index

Public Books As Recordset  'variable to hold books details
Public Deregistered_Books As Recordset  'variable to hold details of books deregistered

Public Books_table As TableDef       'table to hold books details
Public Bk_number As Field  'Books table fields
Public Date_reg As Field
Public Title_field As Field
Public Author_field As Field
Public Borrowing_fee As Field
Public Loanable As Field
Public Loan_period As Field
Public Publisher_field  As Field
Public Supplier_field As Field
Public Dewey_field As Field
Public Class_field As Field
Public ISBN_field As Field
Public Remark_field As Field
Public Deregistered As Field
Public Cancellation_remark As Field
Public Reason As Field
    
Public Subscriber_table As TableDef
Public Terminated_subscriptions_tbl As TableDef
Public Subscribers As Recordset
Public Terminated_subscriptions As Recordset

Public SubscriberID As Field
Public National_ID As Field
Public Surname As Field
Public Initials As Field
Public Home_address As Field
Public Home_phone_no As Field
Public Contact_address As Field
Public Contact_phone_no As Field
Public Expiry_date As Field
Public Borrowing_limit As Field
    
Public Borrowed_books_table As TableDef
Public Date_borrowed As Field
Public Date_due As Field
Public Borrowed_books As Recordset

Public Requested_books_table As TableDef
Public Date_requested As Field
Public Requested_books As Recordset

Public Time_in As Field
Public User_name_field As Field
Public Time_out As Field
Public SessionID_fld As Field
    
Public User_log_table As TableDef
Public User_log As Recordset
Public User_log_index As Index

Public Direct_SQL As QueryDef
Public SQL_result As Recordset

Public Report_query As QueryDef

Public Temporary_date_store As Date


Sub Declare_variables()
    New_line = Chr$(13) + Chr$(10)
    Beep
End Sub



Public Sub Deregister_book_or_subscriber(Focus$, Identification$)
        
    Dim Main_caption As String
    Dim Sub_caption As String
    
    If UCase$(Focus$) = "BOOK" Then
        Main_caption = "Deregister Book"
        Sub_caption = "Book number"
    ElseIf UCase$(Focus$) = "SUBSCRIPTION" Then
        Main_caption = "Terminate Subscription"
        Sub_caption = "Subscriber ID"
    End If
     
    Let frmDeregister_book_or_subscriber.Caption = Main_caption
    Let frmDeregister_book_or_subscriber.lblTask_Focus.Caption = Sub_caption
    Let frmDeregister_book_or_subscriber.txtTask_focus.Text = Identification$
    Let frmDeregister_book_or_subscriber.Tag = Focus$
    frmDeregister_book_or_subscriber.Show 1
  
End Sub


Public Function Get_date_number(Data_focus As Object) As Double

    date_part = Int(Val(Left$(Data_focus.Text, 2)))
    month_part = Int(Val(Mid$(Data_focus.Text, 4, 2)))
    year_part = Int(Val(Mid$(Data_focus.Text, 7, 4)))
    
    Get_date_number = DateSerial(year_part, month_part, date_part)

End Function


Public Sub Register_setup_data(myIdentifier As String, _
                                                   myVariable As String)
    
    myIdentifier = UCase(myIdentifier)
    myVariable = myVariable
    Setup.AddNew
        Setup("identifier") = Encrypt(myIdentifier)
        Setup("variable") = Encrypt(myVariable)
    Setup.Update
    
End Sub


Public Sub Erase_setup_data()
    Dim Identifier As String
    
    If Setup.RecordCount <> 0 Then
        Setup.MoveFirst
        Do
            Identifier = UCase(Decrypt(Setup("identifier")))
            If Identifier <> "LICENSED TO" And _
               Identifier <> "SUBSCRIBER ID FORMAT" And _
               Identifier <> "USER 2 ACCESS RIGHTS" And _
               Identifier <> "USER 3 ACCESS RIGHTS" Then
                    Setup.Delete
            End If
            Setup.MoveNext
        Loop Until Setup.EOF
    End If
    
End Sub

Public Sub Declare_formats()
    Dim Subsc_Format_string As String
    Dim Date_format_string As String
    Buttons = vbCritical + vbOKOnly
    
    Subsc_Format_string = Get_setup_data("subscriber id format", True)
    For Counter = 1 To 8
        Subscriber_Id_format(Counter) = Mid$(Subsc_Format_string, Counter, 1)
    Next
    
    Date_format_string = Get_setup_data("date", True)
            
    'determine week day
    Select Case Val(Mid$(Date_format_string, 1, 1))
        Case 1
            myWeekDay$ = "dddd"
        Case 2
            myWeekDay$ = "ddd"
        Case 3
            myWeekDay$ = ""
    End Select
        
    'determine day
    Select Case Val(Mid$(Date_format_string, 2, 1))
        Case 1
            myDay$ = "dd"
        Case 2
            myDay$ = "d"
    End Select
    
    'determine month
    Select Case Val(Mid$(Date_format_string, 3, 1))
        Case 1
            myMonth$ = "mmmm"
        Case 2
            myMonth$ = "mmm"
        Case 3
            myMonth$ = "mm"
        Case 4
            myMonth$ = "m"
    End Select
    
    'determine year
    Select Case Val(Mid$(Date_format_string, 4, 1))
        Case 1
            myYear$ = "yyyy"
        Case 2
            myYear$ = "yy"
    End Select
    
    'determine separator
    Select Case Val(Mid$(Date_format_string, 5, 1))
        Case 1
            mySeparator$ = "/"
        Case 2
            mySeparator$ = "-"
        Case 3
            mySeparator$ = " "
    End Select
    
    If myWeekDay$ = "" Then
        DateFormat = myDay$ + mySeparator$ + myMonth$ + mySeparator$ + myYear$
    Else
        DateFormat = myWeekDay$ + " " + myDay$ + mySeparator$ + _
                     myMonth$ + mySeparator$ + myYear$
    End If
        
End Sub

Public Function Get_setup_data(Setup_item As String, Required As Boolean) As String
    
    Setup_item = Encrypt(UCase(Setup_item))
    Setup.Index = "setup index"
    Setup.Seek "=", Setup_item
    If Setup.NoMatch Then
        If Required Then
            Buttons = vbCritical + vbOKOnly
            msg$ = "The setup file has been corrupted. The system "
            msg$ = msg$ + New_line + "is therefore as of this moment unstable. "
            msg$ = msg$ + New_line + "Please refer to the manual."
            MsgBox msg$, Buttons, "Setup Error"
            End
        Else
            Get_setup_data = ""
        End If
    Else
        Get_setup_data = Decrypt(Setup("variable"))
    End If

End Function


Public Function Tabs(Number_required As Integer) As String
    
    For Counter = 1 To Number_required
        Tabs = Tabs + Chr$(9)
    Next

End Function

Public Function Find_books_borrowed_data(mySubscriberID As String) As String
    
    Dim Txt As String
    
    mySQL = "Parameters [Subscriber] Text; " _
            & "Select * " _
            & "From [books borrowed table] " _
            & "Where [subscriber id] = [Subscriber];"
    
    Query.SQL = mySQL
    Query.Parameters("Subscriber") = mySubscriberID
    Set Temp_recordset = Query.OpenRecordset
    
    If Temp_recordset.RecordCount = 0 Then
        Exit Function
    Else
        Temp_recordset.MoveFirst
        Txt = New_line + "BOOKS BORROWED DETAILS" + New_line + New_line
        Txt = Txt + "Book Number " + Tabs(1) + "Date borrowed" + Space(14) + Tabs(1) + "Date due" + New_line + New_line
        Do
            My_bk_number$ = Format(Temp_recordset("Book number"), "0 000 000 000")
            myDate_Borrowed$ = Format(Temp_recordset("date borrowed"), DateFormat)
            myDate_due$ = Format(Temp_recordset("date due"), DateFormat)
            myLine$ = My_bk_number$ + Tabs(1) + myDate_Borrowed$ + Space(27 - Len(myDate_Borrowed$)) + Tabs(1) + myDate_due$
            Txt = Txt + myLine$ + New_line
            Temp_recordset.MoveNext
        Loop Until Temp_recordset.EOF
        
        Find_books_borrowed_data = Txt
    End If
    
End Function


Public Function Find_requisition_data(mySubscriberID As String) As String

    Dim Txt As String
    
    mySQL = "Parameters [Subscriber] Text; " _
            & "Select * " _
            & "From [books requested table] " _
            & "Where [subscriber id] = [Subscriber];"
    
    Query.SQL = mySQL
    Query.Parameters("Subscriber") = mySubscriberID
    Set Temp_recordset = Query.OpenRecordset
    
    If Temp_recordset.RecordCount = 0 Then
        Exit Function
    Else
        Temp_recordset.MoveFirst
        Txt = New_line + "BOOKS REQUESTED DETAILS" + New_line + New_line
        Txt = Txt + "Book Number " + Tabs(1) + "Date requested" + Space(14) + Tabs(1) + "Expiry date" + New_line + New_line
        
        Do
            My_bk_number$ = Format(Temp_recordset("Book number"), "0 000 000 000")
            myDate_Borrowed$ = Format(Temp_recordset("date requested"), DateFormat)
            myDate_due$ = Format(Temp_recordset("expiry date"), DateFormat)
            myLine$ = My_bk_number$ + Tabs(1) + myDate_Borrowed$ + Space(27 - Len(myDate_Borrowed$)) + Tabs(1) + myDate_due$
            Txt = Txt + myLine$ + New_line
            Temp_recordset.MoveNext
        Loop Until Temp_recordset.EOF
        
        Find_requisition_data = Txt
    End If
    
End Function

Public Function Find_subscriber_name(Subscriber As String) As String
                
        Subscribers.Index = "Subscriberid index"
        Subscribers.Seek "=", Subscriber
        If Subscribers.NoMatch Then
            Find_subscriber_name = "(Not Found)"
        Else
            Find_subscriber_name = Subscribers("subscriber Title") + " " _
                                   + Subscribers("initials") + " " _
                                   + Subscribers("surname")
        End If
        
        
End Function

Public Function Get_formated_address(Txt As String) As String
    Dim All_text_read As Boolean
    Dim myLine As String
    Dim Result As String
    Dim Counter As Integer
    Dim Start_count As Integer
    
    Start_count = 1
    Counter = 1
    Do
        If Mid(Txt, Counter, 2) = New_line Then
            More_than_one_line = True
            myLine = Mid(Txt, Start_count, Counter - Start_count)
            If Result = "" Then
                Result = Result + Tabs(1) + myLine$ + New_line
            Else
                Result = Result + Tabs(2) + myLine$ + New_line
            End If
            Do
                'Skip over line feeds and carriage returns
                Character = Mid(Txt, Counter, 1)
                If Character = Chr(13) Or Character = Chr(10) Then
                    Counter = Counter + 1
                    If Counter > Len(Txt) Then
                        All_text_read = True
                        Exit Do
                    End If
                Else
                    Exit Do
                End If
            Loop
            'Mark where to start reading next line.
            Start_count = Counter
        Else
            If Counter = Len(Txt) Then
                If More_than_one_line = True Then
                    myTabs% = 2
                Else
                    myTabs% = 1
                End If
                'Take note that the last character must also be read
                myLine = Mid(Txt, Start_count, Counter - Start_count + 1)
                Result = Result + Tabs(myTabs%) + myLine$ + New_line
                All_text_read = True
            Else
                Counter = Counter + 1
            End If
        End If
    Loop Until All_text_read
    
    Get_formated_address = Result$



    
End Function

Public Function Get_ini_data(description As String, Optional Not_Required) As String
    Dim myHandle As Integer
    Dim Temp As String
    Dim Code_line As String
    On Local Error GoTo Error_handler
    myHandle = FreeFile
    
    description = UCase(description)
    WindowsPath$ = GetWindowsDir
    Libra_Ini_Path$ = WindowsPath$ + "Libra2GP.ini"
    Open Libra_Ini_Path$ For Input As myHandle
        Do
            Line Input #myHandle, Temp
            Temp = Trim(Temp)
            If UCase(Left(Temp, Len(description))) = description Then
                Code_line = Right(Temp, Len(Temp) - Len(description) - 1)
                Exit Do
            End If
         Loop Until EOF(myHandle)
    Close myHandle
    
    If Code_line = "" Then
        If Not (IsMissing(Not_Required)) Then
            Get_ini_data = ""
        Else
            msg$ = "Unable to determine " + description
            MsgBox msg$, vbCritical, "Initialisation Error"
            End
        End If
    Else
        Get_ini_data = Code_line
    End If

Exit Function

Error_handler:
    If Err.Number = 53 Then
        msg$ = "Could not find Librarius 2000's initialisation file. "
        msg$ = msg$ + "Please ensure that you have run the Database "
        msg$ = msg$ + "Inititialisation utility and that the file is "
        msg$ = msg$ + "in the Windows directory."
        MsgBox msg$, vbCritical, "System Error"
        End
    Else
        Err.Raise Err.Number
    End If
        
End Function

Public Sub Test_next_and_previous_record(myRecordset As Recordset)
    
    If myRecordset.RecordCount <> 0 Then
        'Test for previous record. If there is none, disable the previous
        'button.
        myRecordset.MovePrevious
        If myRecordset.BOF Then
            Screen.ActiveForm.cmdPrevious.Enabled = False
        Else
            Screen.ActiveForm.cmdPrevious.Enabled = True
        End If
        
        myRecordset.MoveNext 'Go back to original record
        
        'Test for next record. If there is none, disable the next
        'button.
        myRecordset.MoveNext
        If myRecordset.EOF = True Then
            Screen.ActiveForm.cmdNext.Enabled = False
        Else
            Screen.ActiveForm.cmdNext.Enabled = True
        End If
        
        myRecordset.MovePrevious 'Go back to original record
    End If
    
End Sub

Public Sub Show_help(Topic As Long)
    With HelpDialogue
        .HelpFile = App.Path + "\Libra.hlp"
        .HelpCommand = cdlHelpContext
        .HelpContext = Topic
        .ShowHelp
    End With
End Sub
