Attribute VB_Name = "Report_and_mail_merge_building_routines"
Attribute VB_Description = "Report and Memo compiling code"
Public Compile_text As String

Public Field_count As Integer
Public Compiling_array() As Variant
Public Array_elements As Integer
Public Const Text_info = 0
Public Const Data_info = 1
Public Off_set As String



Public Function Compile_starndard_letter()

    If First_merge_pass Then
        Build_merge_compiling_array
        Print_merge_letters
    End If
    
End Function

Public Function First_merge_pass() As Boolean
    
    Dim myField As String
    Dim myTemp As String
    Dim Field_count As Integer
    Field_count = 0
    Compile_text = frmReport.txtReport.Text
    
    For Counter = 1 To Len(Compile_text)
        If Mid(Compile_text, Counter, 1) = "{" Then
            myTemp = Get_field(Counter)
            If myTemp <> "" Then
                myField = myTemp
                If Not (Verify_field_name(myField)) Then
                    First_merge_pass = False
                    frmReport.txtReport.SelStart = Counter - 1
                    Exit Function
                Else
                    Field_count = Field_count + 1
                End If
            Else
                First_merge_pass = False
                frmReport.txtReport.SelStart = Counter - 1
                Exit Function
            End If
        End If
    Next
            
    First_merge_pass = True
    
End Function

Public Function Get_field(Start As Long) As String
    Start = Start + 1
    Buttons = vbOKOnly + vbExclamation
    For Position = Start To Len(Compile_text)
        Character = Mid(Compile_text, Position, 1)
        If Character = "}" Then
            Temp = Mid(Compile_text, Start, Position - Start)
            Get_field = Temp
            Exit For
        ElseIf Character = "{" Then
            msg$ = "New field encountered before the end of previous field"
            MsgBox msg$, Buttons, "Error"
            Exit For
        ElseIf Position = Len(Compile_text) Then
            msg$ = "End of field name not found"
            Exit For
        End If
    Next
    
    If msg$ <> "" Then
        MsgBox msg$, Buttons, "Error"
        Get_field = ""
    ElseIf Temp = "" Then
        msg$ = "Field name not specified."
        MsgBox msg$, Buttons, "Error"
    End If
        
End Function

Public Function Verify_field_name(myField As String) As Boolean
    Dim myObject As Integer
    
    For myObject = 0 To (SQL_result.Fields.Count - 1)
        If UCase(SQL_result.Fields(myObject).Name) = UCase(myField) Then
            Verify_field_name = True
            Exit Function
        End If
    Next
    
    msg$ = "The field name you specified is invalid"
    MsgBox msg$, vbExclamation, "Checking Merge letter"
    
End Function

Public Sub Build_merge_compiling_array()
    Dim myCounter As Long
    
    Erase Compiling_array
    ReDim Compiling_array(1 To 3, 1 To 1)
    
    myCounter = 1
    Compiling_array(1, 1) = Text_info
    Compiling_array(2, 1) = 1
    
    
    For Counter = 1 To Len(Compile_text)
        
        If Mid(Compile_text, Counter, 1) = "{" Then
            Compiling_array(3, myCounter) = Counter - 1
            
            myCounter = myCounter + 1
            ReDim Preserve Compiling_array(1 To 3, 1 To myCounter)
            
            Compiling_array(1, myCounter) = Data_info
            Compiling_array(2, myCounter) = Counter + 1
        ElseIf Mid(Compile_text, Counter, 1) = "}" Then
            Compiling_array(3, myCounter) = Counter - 1
            
            myCounter = myCounter + 1
            ReDim Preserve Compiling_array(1 To 3, 1 To myCounter)
            
            Compiling_array(1, myCounter) = Text_info
            Compiling_array(2, myCounter) = Counter + 1
        End If
     
    Next
    
    If Mid(Compile_text, Len(Compile_text), 1) = "}" Then
        Array_elements = myCounter - 1
    Else
        Compiling_array(3, myCounter) = Len(Compile_text)
        Array_elements = myCounter
    End If
    
End Sub

Public Sub Print_merge_letters()
    Dim Array_element As Long
    Dim Insertion As String
    Dim Field_name As String
    Dim Merge_letter_text As String
    Dim Start_position As Long
    Dim End_position As Long
    Dim myDate As Date

    Set_printer_to_custom_font
    
    SQL_result.MoveFirst
    
    Do
        For Position = 1 To Array_elements
            Start_position = Compiling_array(2, Position)
            End_position = Compiling_array(3, Position)
            Length = End_position - Start_position + 1
            
            
            If Compiling_array(1, Position) = Text_info Then
                Insertion = Mid(Compile_text, Start_position, Length)
                Merge_letter_text = Merge_letter_text + Insertion
            ElseIf Compiling_array(1, Position) = Data_info Then
                Field_name = Mid(Compile_text, Start_position, Length)
                
                Select Case SQL_result.Fields(Field_name).Type
                    Case dbDate
                        myDate = SQL_result.Fields(Field_name).Value
                        Insertion = Format(myDate, DateFormat)
                    Case dbinterger
                        Insertion = Str(SQL_result.Fields(Field_name).Value)
                    Case Else
                        Insertion = SQL_result.Fields(Field_name).Value
                End Select
                Merge_letter_text = Merge_letter_text + Insertion
            End If
        Next Position
        
        
        Printer.Print Merge_letter_text
        Printer.NewPage
        Merge_letter_text = ""
        SQL_result.MoveNext
        
    Loop Until SQL_result.EOF
                        
    Printer.EndDoc
                
End Sub


Public Sub Compile_report()
    
    If Paper_width_verified Then
        Build_report_array
        Print_report
        
    End If
    
End Sub

Public Function Paper_width_verified()
    
    Dim Trimmed_total As Long
       
    On Local Error GoTo Error_handler
    frmReport.MyDialogue.Flags = cdlPDPrintSetup
    frmReport.MyDialogue.ShowPrinter
    Printer.ScaleMode = vbCharacters
    Trimmed_total = Get_trimmed_total
    No_of_fields_chosen = Get_number_of_fields_chosen
    
    If Trimmed_total = 0 Then
        msg$ = "There are no fields to be printed."
    ElseIf (Trimmed_total + No_of_fields_chosen) > Printer.ScaleWidth Then
        Declare_variables
        msg$ = "There total combined length of your fields is more than "
        msg$ = msg$ + "what your currently selected paper size can accomodate." + New_line
        msg$ = msg$ + "Your printer can accomodate "
        msg$ = msg$ + Str(Printer.ScaleWidth) + " Characters" + New_line
        msg$ = msg$ + "Your fields will take up " + Str(Trimmed_total + No_of_fields_chosen)
        msg$ = msg$ + " characters made up of " + Str(No_of_fields_chosen)
        msg$ = msg$ + " field separators and " + Str(Trimmed_total)
        msg$ = msg$ + " characters for the actual fields."
        
    End If
    
    If msg$ <> "" Then
        MsgBox msg$, vbExclamation, "Build Report"
        Paper_width_verified = False
    Else
        Paper_width_verified = True
    End If
    
Exit Function

Error_handler:
    If Err.Number = cdlCancel Then
        Paper_width_verified = False
        Exit Function
    Else
        Err.Raise (Err.Number)
    End If
Resume
    
    
End Function

Public Function Get_number_of_fields_chosen() As Long

    Dim Temp As Long
    Temp = frmSelect_report_fields.lstFields_chosen.ListCount
    Get_number_of_fields_chosen = Temp
    
End Function

Public Sub Build_report_array()
    Dim Print_fields As Integer
    Dim Total As Integer
    Dim myValue As Integer
    Dim Field_name As String
    
    Const colField_name = 1
    Const colData_type = 2
    Const colTrimmed_len = 3
    Const colStart_at = 4
       
    Print_fields = frmSelect_report_fields.lstFields_chosen.ListCount
    ReDim Compiling_array(1 To 4, 1 To Print_fields)
    
    Counter = 0
    For Counter = 0 To (Print_fields - 1)
        Field_name = frmSelect_report_fields.lstFields_chosen.List(Counter)
        Compiling_array(colField_name, Counter + 1) = Field_name
        Compiling_array(colData_type, Counter + 1) = Get_data_type(Field_name)
        Compiling_array(colTrimmed_len, Counter + 1) = Get_trimmed_length(Field_name)
    Next
        
    Compiling_array(colStart_at, 1) = 0
    Total = Compiling_array(colTrimmed_len, 1)
    
    If UBound(Compiling_array, 2) > 1 Then
        For Counter = 2 To UBound(Compiling_array, 2)
            myValue = Total + 3
            Compiling_array(colStart_at, Counter) = myValue
            Total = Total + Compiling_array(colTrimmed_len, Counter) + 1
        Next
    End If
        
        
        
        
End Sub
Public Function Get_data_type(Field_name As String) As Integer
    
    Field_name = UCase$(Trim(Field_name))
    
    For myField_no = 0 To (SQL_result.Fields.Count - 1)
        If Trim(UCase(SQL_result.Fields(myField_no).Name)) = Field_name Then
            Get_data_type = SQL_result.Fields(myField_no).Type
            Exit For
        End If
    Next
    
End Function

Public Function Get_trimmed_length(Field_name As String) As Integer
    
    Already_working = True
    Field_name = UCase$(Trim(Field_name))

    For myCounter = 1 To frmTrim_fields.Grid1.Rows
        frmTrim_fields.Grid1.Col = 1
        frmTrim_fields.Grid1.Row = myCounter
        If UCase(Trim(frmTrim_fields.Grid1.Text)) = Field_name Then
            frmTrim_fields.Grid1.Col = 4
            If Val(frmTrim_fields.Grid1.Text) <> 0 Then
                myWidth = Val(frmTrim_fields.Grid1.Text)
                Get_trimmed_length = myWidth
            Else
                frmTrim_fields.Grid1.Col = 3
                Get_trimmed_length = Val(frmTrim_fields.Grid1.Text)
            End If
            Exit For
        End If
    Next
                
    Already_working = False
    
    
End Function

Public Sub Print_report()
    Dim myStr As String
    Dim myDate As Date
    Dim Offset As Integer
    
    Const colField_name = 1
    Const colData_type = 2
    Const colTrimmed_len = 3
    Const colStart_at = 4
    
    SQL_result.MoveFirst
    Print_report_headers
    For rec_count = 1 To SQL_result.RecordCount
        Offset = 0
        For Counter = 1 To UBound(Compiling_array, 2)
            
            If Compiling_array(2, Counter) = dbDate Then
                If IsNull(SQL_result(Compiling_array(1, Counter))) Then
                    myStr = " "
                Else
                    If Compiling_array(3, Counter) = 21 Then
                        Format_str$ = "dd/mm/yyyy hh:nn"
                    Else
                        Format_str$ = "dd/mm/yyyy"
                    End If
                    myDate = SQL_result(Compiling_array(1, Counter))
                    myStr = Format(myDate, Format_str$)
                End If
            ElseIf Compiling_array(2, Counter) = dbText Then
                myStr = SQL_result(Compiling_array(1, Counter))
                If Not (Contains_carriage_return(myStr)) Then
                    myStr = Mid(myStr, 1, Compiling_array(3, Counter))
                End If
                
            Else
                myStr = Trim(Str(SQL_result(Compiling_array(1, Counter))))
            End If
            
            Printer.CurrentX = Compiling_array(4, Counter)
            If Contains_carriage_return(myStr) Then
                Temp = Print_multiline_text(myStr)
            Else
                myStr = myStr + Space(3)
                Printer.Print myStr;
                Temp = 1
            End If
            
            If Temp > Offset Then
                Offset = Temp
            End If
        Next
         
        Printer.CurrentY = Printer.CurrentY + Offset
        SQL_result.MoveNext
    Next
    
    Printer.EndDoc
    
End Sub

Public Function Print_report_headers() As Integer
    Const colField_name = 1
    Const colData_type = 2
    Const colTrimmed_len = 3
    Const colStart_at = 4
    
    Printer.ScaleMode = vbCharacters
    
    Printer.CurrentY = 0
    
    Set_printer_to_custom_font
    Printer.Print frmReport.txtReport.Text
    Set_printer_to_default_font
    
    Printer.CurrentY = Printer.CurrentY + 2
    
    For Counter = 1 To UBound(Compiling_array, 2)
        myStr = Compiling_array(colField_name, Counter)
        myStr = Mid(myStr, 1, Compiling_array(colTrimmed_len, Counter))
        myStr = myStr + Space(3)
        Printer.CurrentX = Compiling_array(colStart_at, Counter)
        Printer.Print myStr;
    Next
    
    Printer.CurrentY = Printer.CurrentY + 2
    Printer.Line (0, Printer.CurrentY)-(Printer.ScaleWidth, Printer.CurrentY)
    Printer.CurrentY = Printer.CurrentY + 3

End Function

Public Function Contains_carriage_return(myStr As String) As Boolean
    For myCounter = 1 To Len(myStr)
        Character = Mid(myStr, myCounter, 1)
        If Character = Chr(13) Then
            Contains_carriage_return = True
            Exit For
        End If
    Next
    
End Function

Public Function Print_multiline_text(myStr As String) As Integer
    Dim New_line As String * 2
    Dim First_line As Integer
    Dim First_row As Integer
    Dim Offset As Integer
    Dim Current_char As String * 1
    Dim Counter As Integer
    Dim Last_count As Integer
    
        
    Dim Carriage_return As String * 1
    Dim Line_feed As String * 1
    
    Carriage_return = Chr(13)
    Line_feed = Chr(10)
    
    Last_count = 0
    Counter = 1
    First_line = Printer.CurrentY
    First_row = Printer.CurrentX
    
    While (Counter <= Len(myStr))
        Current_char = Mid(myStr, Counter, 1)
        If ((Current_char = Carriage_return) Or (Current_char = Line_feed)) Then
            myLine$ = Mid(myStr, Last_count + 1, Counter - Last_count - 1)
            myLine$ = myLine$ + Space(3)
            
            Printer.CurrentX = First_row
            Printer.Print myLine$
            
            Last_count = Counter + 1
            While (((Current_char = Carriage_return) Or (Current_char = Line_feed)) And Counter <= Len(myStr))
                Counter = Counter + 1
                Current_char = Mid(myStr, Counter, 1)
            Wend
        Else
            Counter = Counter + 1
        End If
    Wend
    
    myLine$ = Mid(myStr, Last_count + 1, Counter - Last_count) + Space(3)
    Printer.CurrentX = First_row
    Printer.Print myLine$
    
    Print_multiline_text = (Printer.CurrentY - First_line) + 1
    Printer.CurrentY = First_line
    
End Function
